
# Contributing to Countly

Countly is a big project and we are happy to receive contributors with different skills: 

* If you know Javascript and HTML5/CSS you can contribute to core layer and user interface of Countly. 
* If you know MongoDB and Node.js, you can contribute to database layer. 
* If you know Java, you can contribute to [Countly Android SDK](https://github.com/countly/countly-sdk-android). 
* If you know Objective-C, you can contribute to [Countly iOS SDK](https://github.com/countly/countly-sdk-ios). 
* If you know any other language, you can start writing your own SDK and help others use Countly as a backend. 
[Here's a list of SDKs that Countly supports](https://count.ly/resources/source/download-sdk).

## Contribution areas 

You can always send a pull request to Countly Community Edition or to Countly SDKs for the following: 

* New features, small or big, including installation, integration, tests, user interface, user experience, extra platforms and such.  
* Bugfixes (excluding translations, explained below) 
* Inefficient code
* Documentation (including installation, deployment to various platforms, video training) 

Before sending a pull request, we expect you first check 
[all new issues](https://github.com/countly/countly-server/issues/) before putting your effort. It's also better to 
test your code thoroughly before sending it over. Also please check existing code to have an understanding of how we work. 

Before starting, you may want to check Github's guide on [contributing open source projects](https://guides.github.com/activities/contributing-to-open-source/).

## Translations

All translations take place on [Transifex Countly page](transifex.com/projects/p/countly). Please check if your language 
is not there, or has a small percentage of translation. Create your account and apply to be a translator. 

## 
